<?php

namespace Z14\Z14ComvahroBewerber3\Routing\Aspect;

use TYPO3\CMS\Core\Routing\Aspect\StaticMappableAspectInterface;

class IdentifierMapper implements StaticMappableAspectInterface
{
    /**
     * @var array
     */
    protected $settings;

    /**
     * @var string
     */
    protected $regex;

    /**
     * @param array $settings
     * @throws \InvalidArgumentException
     */
    public function __construct(array $settings)
    {
        $regex = $settings['regex'] ?? null;

        if (!is_string($regex)) {
            throw new \InvalidArgumentException('regex must be string', 1537277163);
        }

        $this->settings = $settings;
        $this->regex = $regex;
    }

    /**
     * @inheritDoc
     */
    public function generate(string $value): ?string
    {
        $match = preg_match('#' . $this->regex . '#', $value);
        return $match === 1 ? $value : 0;
    }

    /**
     * @inheritDoc
     */
    public function resolve(string $value): ?string
    {
        $match = preg_match('#' . $this->regex . '#', $value);
        return $match === 1 ? $value : 0;
    }
}